import subprocess


def pre_install():
    """
    Do any setup required before the install hook.
    """
    install_pip()
    install_jujuresources()
    install_charmhelpers()


def install_pip():
    subprocess.check_call(['apt-get', 'install', '-yq', 'python-pip', 'bzr'])


def install_jujuresources():
    """
    Install the jujuresources library from Launchpad, if not present.
    """
    # TODO Support bootstrapping from bundled egg
    try:
        import jujuresources  # noqa
    except ImportError:
        subprocess.check_call([
            'pip', 'install',
            'bzr+http://bazaar.launchpad.net/~johnsca/jujuresources/trunk#egg=jujuresources'])


def install_charmhelpers():
    """
    Install the charmhelpers library, if not present.
    """
    try:
        import charmhelpers  # noqa
    except ImportError:
        # TODO convert to wheel managed by jujuresources
        subprocess.check_call([
            'pip', 'install',
            'bzr+http://bazaar.launchpad.net/~bigdata-dev/charm-helpers/framework#egg=charmhelpers'])
